<?php

namespace RxConnexionBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;
use RxConnexionBundle\Entity\Base\BaseEntity;
use Symfony\Component\Form\Extension\Core\DataTransformer\DateTimeToStringTransformer;

/**
 * @ORM\Entity(repositoryClass="RxConnexionBundle\Repository\ScheduleQueuedRepository")
 * @ORM\Table(name="schedule_queued")
 */

class ScheduleQueuedEntity extends BaseEntity
{
    /**
     * @ORM\Column(name="schedule_date", type="datetime")
     */
    protected $scheduleDate;

    /**
     * @ORM\Column(name="notes", type="text", nullable=true)
     */
    protected $notes;

    /**
     * @ORM\Column(name="is_queued", type="boolean", nullable=true)
     */
    protected $isQueued = true;

    /**
     * @ORM\Column(name="queue_no", type="integer", nullable=true)
     */
    protected $queueNo;

    /**
     * @ORM\Column(name="is_deleted", type="boolean")
     */
    protected $isDeleted;

    /**
     * @ORM\ManyToOne(targetEntity="HealthFacilityEntity", inversedBy="schedulesQueued")
     * @ORM\JoinColumn(name="health_facility_id", referencedColumnName="id")
     */
    protected $healthFacility;

    /**
     * @ORM\ManyToOne(targetEntity="PatientEntity", inversedBy="schedulesQueued")
     * @ORM\JoinColumn(name="patient_id", referencedColumnName="id")
     */
    protected $patient;

    /**
     * @ORM\ManyToOne(targetEntity="ScheduleQueuedStatusEntity", inversedBy="schedulesQueued")
     * @ORM\JoinColumn(name="schedule_queued_status_id", referencedColumnName="id")
     */
    protected $scheduleQueuedStatus;

    /**
     * @ORM\ManyToOne(targetEntity="ProviderEntity", inversedBy="schedulesQueued")
     * @ORM\JoinColumn(name="provider_id", referencedColumnName="id")
     */
    protected $provider;

    /**
     * @ORM\ManyToOne(targetEntity="ChartTypeEntity", inversedBy="schedulesQueued")
     * @ORM\JoinColumn(name="chart_type_id", referencedColumnName="id")
     */
    protected $chartType;

    /**
     * @ORM\OneToOne(targetEntity="ScheduleRequestEntity", inversedBy="scheduleQueued")
     * @ORM\JoinColumn(name="schedule_request_id", referencedColumnName="id")
     */
    protected $scheduleRequest;

    /**
     * Set createdAt
     *
     * @ORM\PrePersist
     */
    public function setCreatedAtValue()
    {
        parent::setCreatedAtValue();
        $this->isDeleted = 0;
    }

    /*--------------------------------------------------------------------------------------------------------*/
    /*					Use Defined Setters and Getters														  */
    /*--------------------------------------------------------------------------------------------------------*/

    /*--------------------------------------------------------------------------------------------------------*/
    /*					Setters and Getters																	  */
    /*--------------------------------------------------------------------------------------------------------*/


    /**
     * Set scheduleDate
     *
     * @param \DateTime $scheduleDate
     *
     * @return ScheduleQueuedEntity
     */
    public function setScheduleDate($scheduleDate)
    {
        $this->scheduleDate = $scheduleDate;

        return $this;
    }

    /**
     * Get scheduleDate
     *
     * @return \DateTime
     */
    public function getScheduleDate()
    {
        return $this->scheduleDate;
    }

    /**
     * Set notes
     *
     * @param string $notes
     *
     * @return ScheduleQueuedEntity
     */
    public function setNotes($notes)
    {
        $this->notes = $notes;

        return $this;
    }

    /**
     * Get notes
     *
     * @return string
     */
    public function getNotes()
    {
        return $this->notes;
    }

    /**
     * Set isQueued
     *
     * @param boolean $isQueued
     *
     * @return ScheduleQueuedEntity
     */
    public function setIsQueued($isQueued)
    {
        $this->isQueued = $isQueued;

        return $this;
    }

    /**
     * Get isQueued
     *
     * @return boolean
     */
    public function getIsQueued()
    {
        return $this->isQueued;
    }

    /**
     * Set queueNo
     *
     * @param integer $queueNo
     *
     * @return ScheduleQueuedEntity
     */
    public function setQueueNo($queueNo)
    {
        $this->queueNo = $queueNo;

        return $this;
    }

    /**
     * Get queueNo
     *
     * @return integer
     */
    public function getQueueNo()
    {
        return $this->queueNo;
    }

    /**
     * Set healthFacility
     *
     * @param \RxConnexionBundle\Entity\HealthFacilityEntity $healthFacility
     *
     * @return ScheduleQueuedEntity
     */
    public function setHealthFacility(\RxConnexionBundle\Entity\HealthFacilityEntity $healthFacility = null)
    {
        $this->healthFacility = $healthFacility;

        return $this;
    }

    /**
     * Get healthFacility
     *
     * @return \RxConnexionBundle\Entity\HealthFacilityEntity
     */
    public function getHealthFacility()
    {
        return $this->healthFacility;
    }

    /**
     * Set patient
     *
     * @param \RxConnexionBundle\Entity\PatientEntity $patient
     *
     * @return ScheduleQueuedEntity
     */
    public function setPatient(\RxConnexionBundle\Entity\PatientEntity $patient = null)
    {
        $this->patient = $patient;

        return $this;
    }

    /**
     * Get patient
     *
     * @return \RxConnexionBundle\Entity\PatientEntity
     */
    public function getPatient()
    {
        return $this->patient;
    }

    /**
     * Set scheduleQueuedStatus
     *
     * @param \RxConnexionBundle\Entity\ScheduleQueuedStatusEntity $scheduleQueuedStatus
     *
     * @return ScheduleQueuedEntity
     */
    public function setScheduleQueuedStatus(\RxConnexionBundle\Entity\ScheduleQueuedStatusEntity $scheduleQueuedStatus = null)
    {
        $this->scheduleQueuedStatus = $scheduleQueuedStatus;

        return $this;
    }

    /**
     * Get scheduleQueuedStatus
     *
     * @return \RxConnexionBundle\Entity\ScheduleQueuedStatusEntity
     */
    public function getScheduleQueuedStatus()
    {
        return $this->scheduleQueuedStatus;
    }

    /**
     * Set provider
     *
     * @param \RxConnexionBundle\Entity\ProviderEntity $provider
     *
     * @return ScheduleQueuedEntity
     */
    public function setProvider(\RxConnexionBundle\Entity\ProviderEntity $provider = null)
    {
        $this->provider = $provider;

        return $this;
    }

    /**
     * Get provider
     *
     * @return \RxConnexionBundle\Entity\ProviderEntity
     */
    public function getProvider()
    {
        return $this->provider;
    }

    /**
     * Set chartType
     *
     * @param \RxConnexionBundle\Entity\ChartTypeEntity $chartType
     *
     * @return ScheduleQueuedEntity
     */
    public function setChartType(\RxConnexionBundle\Entity\ChartTypeEntity $chartType = null)
    {
        $this->chartType = $chartType;

        return $this;
    }

    /**
     * Get chartType
     *
     * @return \RxConnexionBundle\Entity\ChartTypeEntity
     */
    public function getChartType()
    {
        return $this->chartType;
    }

    /**
     * Set scheduleRequest
     *
     * @param \RxConnexionBundle\Entity\ScheduleRequestEntity $scheduleRequest
     *
     * @return ScheduleQueuedEntity
     */
    public function setScheduleRequest(\RxConnexionBundle\Entity\ScheduleRequestEntity $scheduleRequest = null)
    {
        $this->scheduleRequest = $scheduleRequest;

        return $this;
    }

    /**
     * Get scheduleRequest
     *
     * @return \RxConnexionBundle\Entity\ScheduleRequestEntity
     */
    public function getScheduleRequest()
    {
        return $this->scheduleRequest;
    }

    /**
     * Get id
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set createdBy
     *
     * @param string $createdBy
     *
     * @return ScheduleQueuedEntity
     */
    public function setCreatedBy($createdBy)
    {
        $this->createdBy = $createdBy;

        return $this;
    }

    /**
     * Get createdBy
     *
     * @return string
     */
    public function getCreatedBy()
    {
        return $this->createdBy;
    }

    /**
     * Set createdAt
     *
     * @param \DateTime $createdAt
     *
     * @return ScheduleQueuedEntity
     */
    public function setCreatedAt($createdAt)
    {
        $this->createdAt = $createdAt;

        return $this;
    }

    /**
     * Get createdAt
     *
     * @return \DateTime
     */
    public function getCreatedAt()
    {
        return $this->createdAt;
    }

    /**
     * Set updatedBy
     *
     * @param string $updatedBy
     *
     * @return ScheduleQueuedEntity
     */
    public function setUpdatedBy($updatedBy)
    {
        $this->updatedBy = $updatedBy;

        return $this;
    }

    /**
     * Get updatedBy
     *
     * @return string
     */
    public function getUpdatedBy()
    {
        return $this->updatedBy;
    }

    /**
     * Set updatedAt
     *
     * @param \DateTime $updatedAt
     *
     * @return ScheduleQueuedEntity
     */
    public function setUpdatedAt($updatedAt)
    {
        $this->updatedAt = $updatedAt;

        return $this;
    }

    /**
     * Get updatedAt
     *
     * @return \DateTime
     */
    public function getUpdatedAt()
    {
        return $this->updatedAt;
    }

    /**
     * Set isDeleted
     *
     * @param boolean $isDeleted
     *
     * @return ScheduleQueuedEntity
     */
    public function setIsDeleted($isDeleted)
    {
        $this->isDeleted = $isDeleted;

        return $this;
    }

    /**
     * Get isDeleted
     *
     * @return boolean
     */
    public function getIsDeleted()
    {
        return $this->isDeleted;
    }
}
